%% Variables
global x xav U S Aq Power transm averaging vilkaarlige metode P_peak Xmin
% An empty queue with the lenght of t transmissions;
t = 1000000; % How many runs
maxLength = 100000;
averaging = 100;
tids = zeros(1,ceil(t/maxLength));
l = 1;
%%%%%Changable vars variables%%%%%
k = 1; % The probability of arrival to the queue
bit =0.1; % The ammount arriving to the queue
increase = .1; % How much one of the variables should increase
xav = 1; % Should be mean SNR
Xmin = 0.1; % The minimum itnterference to use in powerallocation (also regulate max power)
P_peak = 1.5; % Maximum transmit power. 

% runs or sample
metode = 'sample';
bitminav = 1; % 1 for change in bit, 2 for change in Xmin, 3 for change in Xav.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

c = clock;
if c(4) < 10
  tempTid = ['0' num2str(c(4))];
else
  tempTid = num2str(c(4));
end
if c(5) < 10
  tempTid = [tempTid '0' num2str(c(5))];
else
  tempTid = [tempTid num2str(c(5))];
end
  
savePath = strcat('simulering/',date,'--',tempTid,'/');



instilling = struct(...
  'savePath',savePath,'t',t,'maxLength',maxLength,...
  'averaging',averaging,'l',l,'k',k,'bit',bit,'P_peak',P_peak,...
  'xav',xav,'Xmin',Xmin,'metode',metode,...
  'bitminav',bitminav,'increase',increase);
if(~exist(savePath,'file'))
  mkdir(savePath)
end
save(strcat(savePath,'instilling.mat'),'-struct','instilling')
%save(strcat(savePath,'instilling.txt'),'instilling','-ASCII')

meanU = zeros(1,size(tids,2));
U = zeros(1,maxLength);
x = zeros(1,maxLength);
x(1) = 1;
S = zeros(2,maxLength);
Aq = zeros(1,maxLength);
vilkaarlige = zeros(1,maxLength);
Power = zeros(1,maxLength);
transm = zeros(1,maxLength);

Gl = 1; % is one when both receiver and transmitter
        % is omnidirectional

%% Runtime
while( t > 0 )
  tic
  if (t > maxLength)
    j = maxLength;
  else
    j = t;
  end
  S(1,:) = s_Trans(1,1,j);
  S(2,:) = s_Trans(1,1,j);
  vilkaarlige = rand(1,maxLength);
  for i=1:j;
    if (i == j)
      if tids(1) == 0
        saveFiles(savePath)
      else 
        saveFiles(savePath,'-append')
      end
      if t-i == 0
      elseif strcmp(metode,'runs')
        meanU(l) = mean(U);
        U(1) = Utran(i,U(i),S,bit,k); 
      elseif strcmp(metode,'sample')
        U(1) = 0;
      end
    elseif strcmp(metode,'runs')
      U(i+1) = Utran(i,U(i),S,bit,k);
    elseif strcmp(metode,'sample')
      U(i+1) = Utran(i,U(i),S,bit,k);
    end      
    %U(i+1) = Utran(i,U(i),1);
  end
  tids(l) = toc;
  if t-j==0 && j < maxLength
    U(j+1:size(U,2))=0;
    x(j+1:size(x,2))=0;
    S(1,j+1:size(S,2))=0;
    S(2,j+1:size(S,2))=0;
    Aq(j+1:size(U,2))=0;
    transm(j+1:size(U,2))=0;
  end
  if (tids(2) == 0)
    disp(['Estimated time to run the simulation is ' tiden(tids(1)*(t/maxLength))])
  else
    disp(['Esitmated time left is ' tiden(mean(tids(1:l))*(size(meanU,2)-l))])
  end
  t = t-j;
  l = l+1;
  if strcmp(metode,'sample')
    switch bitminav
      case 1;
        bit = bit+increase;
      case 2;
        Xmin = Xmin+increase;
      case 3;
        xav = xav+increase;
    end
  end
end

disp(['The time it took to run the simulation is ' tiden(sum(tids))])
