% The queue management, Utran updates the queue length U every time it is
% run, does not need the t. pTrans is supposed to be the variable power,
% used to minimize the interference at the primary user. s_Trans is the
% state of the link. uTrans is how much is transmitted trough the link. and
% aQueue is how much that has arrived to the queue.

function retur = Utran(j,u_temp,S,varargin) 
  if size(varargin,2) == 1
    bit = varargin{1};
    k = 0.1;
  elseif size(varargin,2) >= 2
    bit = varargin{1};
    k = varargin{2};
  else
    k = 0.1;
    bit = 10;
  end
  p = pTrans(j,S(1,j),S(2,j));
  retur = max([u_temp-uTrans(j,p,S(2,j)),0])+aQueue(j,bit,k);
  %retur = max([u_temp-uTrans(j,1,S(2,j)),0])+aQueue(j,bit,k);
end
