function retur = pTrans(t,varargin)
  global U x xav Power metode P_peak Xmin
  S = [0 0];
  if size(varargin,2) >= 2
    S(1) = varargin{1};
    S(2) = varargin{2};
    
    prev = x(t);

    P_transm = 2*U(t)/prev-1/S(1);
    Power(t) = min(max(P_transm,0),P_peak);

    if (t == size(x,2))
      if strcmp(metode,'runs')
        x(1)=max(max(prev-xav,0)+Power(t)*S(2),Xmin);
      elseif strcmp(metode,'sample')
        x(1)=1;
      end
    else
      x(t+1)=max(max(prev-xav,0)+Power(t)*S(2),Xmin);
    end
  else
    Power(t) = 1;
  end
  retur = Power(t);
end